﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Globalization;

namespace howto_401k
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Compare regular and 401k account balances.
        private void btnGo_Click(object sender, EventArgs e)
        {
            decimal annual_contribution =
                decimal.Parse(txtAnnualContribution.Text, NumberStyles.Any);

            decimal tax_rate =
                decimal.Parse(txtTaxRate.Text.Replace("%", ""),
                    NumberStyles.Any) / 100;
            if (tax_rate >= 1) tax_rate /= 100;

            decimal interest_rate =
                decimal.Parse(txtInterestRate.Text.Replace("%", ""),
                    NumberStyles.Any) / 100;
            if (interest_rate >= 1) interest_rate /= 100;

            int num_years = int.Parse(txtYears.Text);

            decimal balance_bank = 0;
            decimal balance_401k = 0;
            lvwResults.Items.Clear();
            for (int year = 0; year < num_years; year++)
            {
                ListViewItem lv_item = new ListViewItem(year.ToString());
                lvwResults.Items.Add(lv_item);
                lv_item.SubItems.Add(balance_bank.ToString("C"));
                lv_item.SubItems.Add(balance_401k.ToString("C"));

                // Bank balance += interest + contribution, minus taxes.
                balance_bank = balance_bank +
                    (1 - tax_rate) * (balance_bank * interest_rate + annual_contribution);

                // 401(k) balance += interest + contribution.
                balance_401k = balance_401k +
                    (balance_401k * interest_rate + annual_contribution);
            }
        }
    }
}
